
//----------------------------------------
// The code is automatically generated by the GenlibLcl tool.
// Copyright © ying32. All Rights Reserved.
// 
// Licensed under Apache License 2.0
//
//----------------------------------------


package vcl


import (
    . "github.com/ying32/govcl/vcl/api"
    . "github.com/ying32/govcl/vcl/types"
    "unsafe"
)

type TImage struct {
    IControl
    instance uintptr
    // 特殊情况下使用，主要应对Go的GC问题，与LCL没有太多关系。
    ptr unsafe.Pointer
}

// 创建一个新的对象。
// 
// Create a new object.
func NewImage(owner IComponent) *TImage {
    i := new(TImage)
    i.instance = Image_Create(CheckPtr(owner))
    i.ptr = unsafe.Pointer(i.instance)
    // 不敢启用，因为不知道会发生什么...
    // runtime.SetFinalizer(i, (*TImage).Free)
    return i
}

// 动态转换一个已存在的对象实例。
// 
// Dynamically convert an existing object instance.
func AsImage(obj interface{}) *TImage {
    instance, ptr := getInstance(obj)
    if instance == 0 { return nil }
    return &TImage{instance: instance, ptr: ptr}
}

// -------------------------- Deprecated begin --------------------------
// 新建一个对象来自已经存在的对象实例指针。
// 
// Create a new object from an existing object instance pointer.
// Deprecated: use AsImage.
func ImageFromInst(inst uintptr) *TImage {
    return AsImage(inst)
}

// 新建一个对象来自已经存在的对象实例。
// 
// Create a new object from an existing object instance.
// Deprecated: use AsImage.
func ImageFromObj(obj IObject) *TImage {
    return AsImage(obj)
}

// 新建一个对象来自不安全的地址。注意：使用此函数可能造成一些不明情况，慎用。
// 
// Create a new object from an unsecured address. Note: Using this function may cause some unclear situations and be used with caution..
// Deprecated: use AsImage.
func ImageFromUnsafePointer(ptr unsafe.Pointer) *TImage {
    return AsImage(ptr)
}

// -------------------------- Deprecated end --------------------------
// 释放对象。
// 
// Free object.
func (i *TImage) Free() {
    if i.instance != 0 {
        Image_Free(i.instance)
        i.instance, i.ptr = 0, nullptr
    }
}

// 返回对象实例指针。
// 
// Return object instance pointer.
func (i *TImage) Instance() uintptr {
    return i.instance
}

// 获取一个不安全的地址。
// 
// Get an unsafe address.
func (i *TImage) UnsafeAddr() unsafe.Pointer {
    return i.ptr
}

// 检测地址是否为空。
// 
// Check if the address is empty.
func (i *TImage) IsValid() bool {
    return i.instance != 0
}

// 检测当前对象是否继承自目标对象。
// 
// Checks whether the current object is inherited from the target object.
func (i *TImage) Is() TIs {
    return TIs(i.instance)
}

// 动态转换当前对象为目标对象。
// 
// Dynamically convert the current object to the target object.
//func (i *TImage) As() TAs {
//    return TAs(i.instance)
//}

// 获取类信息指针。
// 
// Get class information pointer.
func TImageClass() TClass {
    return Image_StaticClassType()
}

// 将控件置于最前。
//
// Bring the control to the front.
func (i *TImage) BringToFront() {
    Image_BringToFront(i.instance)
}

// 将客户端坐标转为绝对的屏幕坐标。
//
// Convert client coordinates to absolute screen coordinates.
func (i *TImage) ClientToScreen(Point TPoint) TPoint {
    return Image_ClientToScreen(i.instance, Point)
}

// 将客户端坐标转为父容器坐标。
//
// Convert client coordinates to parent container coordinates.
func (i *TImage) ClientToParent(Point TPoint, AParent IWinControl) TPoint {
    return Image_ClientToParent(i.instance, Point , CheckPtr(AParent))
}

// 是否在拖拽中。
//
// Is it in the middle of dragging.
func (i *TImage) Dragging() bool {
    return Image_Dragging(i.instance)
}

// 是否有父容器。
//
// Is there a parent container.
func (i *TImage) HasParent() bool {
    return Image_HasParent(i.instance)
}

// 隐藏控件。
//
// Hidden control.
func (i *TImage) Hide() {
    Image_Hide(i.instance)
}

// 要求重绘。
//
// Redraw.
func (i *TImage) Invalidate() {
    Image_Invalidate(i.instance)
}

// 发送一个消息。
//
// Send a message.
func (i *TImage) Perform(Msg uint32, WParam uintptr, LParam int) int {
    return Image_Perform(i.instance, Msg , WParam , LParam)
}

// 刷新控件。
//
// Refresh control.
func (i *TImage) Refresh() {
    Image_Refresh(i.instance)
}

// 重绘。
//
// Repaint.
func (i *TImage) Repaint() {
    Image_Repaint(i.instance)
}

// 将屏幕坐标转为客户端坐标。
//
// Convert screen coordinates to client coordinates.
func (i *TImage) ScreenToClient(Point TPoint) TPoint {
    return Image_ScreenToClient(i.instance, Point)
}

// 将父容器坐标转为客户端坐标。
//
// Convert parent container coordinates to client coordinates.
func (i *TImage) ParentToClient(Point TPoint, AParent IWinControl) TPoint {
    return Image_ParentToClient(i.instance, Point , CheckPtr(AParent))
}

// 控件至于最后面。
//
// The control is placed at the end.
func (i *TImage) SendToBack() {
    Image_SendToBack(i.instance)
}

// 设置组件边界。
//
// Set component boundaries.
func (i *TImage) SetBounds(ALeft int32, ATop int32, AWidth int32, AHeight int32) {
    Image_SetBounds(i.instance, ALeft , ATop , AWidth , AHeight)
}

// 显示控件。
//
// Show control.
func (i *TImage) Show() {
    Image_Show(i.instance)
}

// 控件更新。
//
// Update.
func (i *TImage) Update() {
    Image_Update(i.instance)
}

// 获取控件的字符，如果有。
//
// Get the characters of the control, if any.
func (i *TImage) GetTextBuf(Buffer *string, BufSize int32) int32 {
    return Image_GetTextBuf(i.instance, Buffer , BufSize)
}

// 获取控件的字符长，如果有。
//
// Get the character length of the control, if any.
func (i *TImage) GetTextLen() int32 {
    return Image_GetTextLen(i.instance)
}

// 设置控件字符，如果有。
//
// Set control characters, if any.
func (i *TImage) SetTextBuf(Buffer string) {
    Image_SetTextBuf(i.instance, Buffer)
}

// 查找指定名称的组件。
//
// Find the component with the specified name.
func (i *TImage) FindComponent(AName string) *TComponent {
    return AsComponent(Image_FindComponent(i.instance, AName))
}

// 获取类名路径。
//
// Get the class name path.
func (i *TImage) GetNamePath() string {
    return Image_GetNamePath(i.instance)
}

// 复制一个对象，如果对象实现了此方法的话。
//
// Copy an object, if the object implements this method.
func (i *TImage) Assign(Source IObject) {
    Image_Assign(i.instance, CheckPtr(Source))
}

// 获取类的类型信息。
//
// Get class type information.
func (i *TImage) ClassType() TClass {
    return Image_ClassType(i.instance)
}

// 获取当前对象类名称。
//
// Get the current object class name.
func (i *TImage) ClassName() string {
    return Image_ClassName(i.instance)
}

// 获取当前对象实例大小。
//
// Get the current object instance size.
func (i *TImage) InstanceSize() int32 {
    return Image_InstanceSize(i.instance)
}

// 判断当前类是否继承自指定类。
//
// Determine whether the current class inherits from the specified class.
func (i *TImage) InheritsFrom(AClass TClass) bool {
    return Image_InheritsFrom(i.instance, AClass)
}

// 与一个对象进行比较。
//
// Compare with an object.
func (i *TImage) Equals(Obj IObject) bool {
    return Image_Equals(i.instance, CheckPtr(Obj))
}

// 获取类的哈希值。
//
// Get the hash value of the class.
func (i *TImage) GetHashCode() int32 {
    return Image_GetHashCode(i.instance)
}

// 文本类信息。
//
// Text information.
func (i *TImage) ToString() string {
    return Image_ToString(i.instance)
}

func (i *TImage) AnchorToNeighbour(ASide TAnchorKind, ASpace int32, ASibling IControl) {
    Image_AnchorToNeighbour(i.instance, ASide , ASpace , CheckPtr(ASibling))
}

func (i *TImage) AnchorParallel(ASide TAnchorKind, ASpace int32, ASibling IControl) {
    Image_AnchorParallel(i.instance, ASide , ASpace , CheckPtr(ASibling))
}

// 置于指定控件的横向中心。
func (i *TImage) AnchorHorizontalCenterTo(ASibling IControl) {
    Image_AnchorHorizontalCenterTo(i.instance, CheckPtr(ASibling))
}

// 置于指定控件的纵向中心。
func (i *TImage) AnchorVerticalCenterTo(ASibling IControl) {
    Image_AnchorVerticalCenterTo(i.instance, CheckPtr(ASibling))
}

func (i *TImage) AnchorAsAlign(ATheAlign TAlign, ASpace int32) {
    Image_AnchorAsAlign(i.instance, ATheAlign , ASpace)
}

func (i *TImage) AnchorClient(ASpace int32) {
    Image_AnchorClient(i.instance, ASpace)
}

func (i *TImage) AntialiasingMode() TAntialiasingMode {
    return Image_GetAntialiasingMode(i.instance)
}

func (i *TImage) SetAntialiasingMode(value TAntialiasingMode) {
    Image_SetAntialiasingMode(i.instance, value)
}

func (i *TImage) KeepOriginXWhenClipped() bool {
    return Image_GetKeepOriginXWhenClipped(i.instance)
}

func (i *TImage) SetKeepOriginXWhenClipped(value bool) {
    Image_SetKeepOriginXWhenClipped(i.instance, value)
}

func (i *TImage) KeepOriginYWhenClipped() bool {
    return Image_GetKeepOriginYWhenClipped(i.instance)
}

func (i *TImage) SetKeepOriginYWhenClipped(value bool) {
    Image_SetKeepOriginYWhenClipped(i.instance, value)
}

func (i *TImage) StretchInEnabled() bool {
    return Image_GetStretchInEnabled(i.instance)
}

func (i *TImage) SetStretchInEnabled(value bool) {
    Image_SetStretchInEnabled(i.instance, value)
}

func (i *TImage) StretchOutEnabled() bool {
    return Image_GetStretchOutEnabled(i.instance)
}

func (i *TImage) SetStretchOutEnabled(value bool) {
    Image_SetStretchOutEnabled(i.instance, value)
}

// 获取画布。
func (i *TImage) Canvas() *TCanvas {
    return AsCanvas(Image_GetCanvas(i.instance))
}

// 获取控件自动调整。
//
// Get Control automatically adjusts.
func (i *TImage) Align() TAlign {
    return Image_GetAlign(i.instance)
}

// 设置控件自动调整。
//
// Set Control automatically adjusts.
func (i *TImage) SetAlign(value TAlign) {
    Image_SetAlign(i.instance, value)
}

// 获取四个角位置的锚点。
func (i *TImage) Anchors() TAnchors {
    return Image_GetAnchors(i.instance)
}

// 设置四个角位置的锚点。
func (i *TImage) SetAnchors(value TAnchors) {
    Image_SetAnchors(i.instance, value)
}

// 获取自动调整大小。
func (i *TImage) AutoSize() bool {
    return Image_GetAutoSize(i.instance)
}

// 设置自动调整大小。
func (i *TImage) SetAutoSize(value bool) {
    Image_SetAutoSize(i.instance, value)
}

func (i *TImage) Center() bool {
    return Image_GetCenter(i.instance)
}

func (i *TImage) SetCenter(value bool) {
    Image_SetCenter(i.instance, value)
}

// 获取约束控件大小。
func (i *TImage) Constraints() *TSizeConstraints {
    return AsSizeConstraints(Image_GetConstraints(i.instance))
}

// 设置约束控件大小。
func (i *TImage) SetConstraints(value *TSizeConstraints) {
    Image_SetConstraints(i.instance, CheckPtr(value))
}

// 获取设置控件拖拽时的光标。
//
// Get Set the cursor when the control is dragged.
func (i *TImage) DragCursor() TCursor {
    return Image_GetDragCursor(i.instance)
}

// 设置设置控件拖拽时的光标。
//
// Set Set the cursor when the control is dragged.
func (i *TImage) SetDragCursor(value TCursor) {
    Image_SetDragCursor(i.instance, value)
}

// 获取拖拽模式。
//
// Get Drag mode.
func (i *TImage) DragMode() TDragMode {
    return Image_GetDragMode(i.instance)
}

// 设置拖拽模式。
//
// Set Drag mode.
func (i *TImage) SetDragMode(value TDragMode) {
    Image_SetDragMode(i.instance, value)
}

// 获取控件启用。
//
// Get the control enabled.
func (i *TImage) Enabled() bool {
    return Image_GetEnabled(i.instance)
}

// 设置控件启用。
//
// Set the control enabled.
func (i *TImage) SetEnabled(value bool) {
    Image_SetEnabled(i.instance, value)
}

// 获取以父容器的ShowHint属性为准。
func (i *TImage) ParentShowHint() bool {
    return Image_GetParentShowHint(i.instance)
}

// 设置以父容器的ShowHint属性为准。
func (i *TImage) SetParentShowHint(value bool) {
    Image_SetParentShowHint(i.instance, value)
}

// 获取图片。
func (i *TImage) Picture() *TPicture {
    return AsPicture(Image_GetPicture(i.instance))
}

// 设置图片。
func (i *TImage) SetPicture(value *TPicture) {
    Image_SetPicture(i.instance, CheckPtr(value))
}

// 获取右键菜单。
//
// Get Right click menu.
func (i *TImage) PopupMenu() *TPopupMenu {
    return AsPopupMenu(Image_GetPopupMenu(i.instance))
}

// 设置右键菜单。
//
// Set Right click menu.
func (i *TImage) SetPopupMenu(value IComponent) {
    Image_SetPopupMenu(i.instance, CheckPtr(value))
}

// 获取等比缩放。
func (i *TImage) Proportional() bool {
    return Image_GetProportional(i.instance)
}

// 设置等比缩放。
func (i *TImage) SetProportional(value bool) {
    Image_SetProportional(i.instance, value)
}

// 获取显示鼠标悬停提示。
//
// Get Show mouseover tips.
func (i *TImage) ShowHint() bool {
    return Image_GetShowHint(i.instance)
}

// 设置显示鼠标悬停提示。
//
// Set Show mouseover tips.
func (i *TImage) SetShowHint(value bool) {
    Image_SetShowHint(i.instance, value)
}

// 获取拉伸缩放。
func (i *TImage) Stretch() bool {
    return Image_GetStretch(i.instance)
}

// 设置拉伸缩放。
func (i *TImage) SetStretch(value bool) {
    Image_SetStretch(i.instance, value)
}

// 获取透明。
//
// Get transparent.
func (i *TImage) Transparent() bool {
    return Image_GetTransparent(i.instance)
}

// 设置透明。
//
// Set transparent.
func (i *TImage) SetTransparent(value bool) {
    Image_SetTransparent(i.instance, value)
}

// 获取控件可视。
//
// Get the control visible.
func (i *TImage) Visible() bool {
    return Image_GetVisible(i.instance)
}

// 设置控件可视。
//
// Set the control visible.
func (i *TImage) SetVisible(value bool) {
    Image_SetVisible(i.instance, value)
}

// 设置控件单击事件。
//
// Set control click event.
func (i *TImage) SetOnClick(fn TNotifyEvent) {
    Image_SetOnClick(i.instance, fn)
}

// 设置双击事件。
func (i *TImage) SetOnDblClick(fn TNotifyEvent) {
    Image_SetOnDblClick(i.instance, fn)
}

// 设置拖拽下落事件。
//
// Set Drag and drop event.
func (i *TImage) SetOnDragDrop(fn TDragDropEvent) {
    Image_SetOnDragDrop(i.instance, fn)
}

// 设置拖拽完成事件。
//
// Set Drag and drop completion event.
func (i *TImage) SetOnDragOver(fn TDragOverEvent) {
    Image_SetOnDragOver(i.instance, fn)
}

// 设置拖拽结束。
//
// Set End of drag.
func (i *TImage) SetOnEndDrag(fn TEndDragEvent) {
    Image_SetOnEndDrag(i.instance, fn)
}

// 设置鼠标按下事件。
//
// Set Mouse down event.
func (i *TImage) SetOnMouseDown(fn TMouseEvent) {
    Image_SetOnMouseDown(i.instance, fn)
}

// 设置鼠标进入事件。
//
// Set Mouse entry event.
func (i *TImage) SetOnMouseEnter(fn TNotifyEvent) {
    Image_SetOnMouseEnter(i.instance, fn)
}

// 设置鼠标离开事件。
//
// Set Mouse leave event.
func (i *TImage) SetOnMouseLeave(fn TNotifyEvent) {
    Image_SetOnMouseLeave(i.instance, fn)
}

// 设置鼠标移动事件。
func (i *TImage) SetOnMouseMove(fn TMouseMoveEvent) {
    Image_SetOnMouseMove(i.instance, fn)
}

// 设置鼠标抬起事件。
//
// Set Mouse lift event.
func (i *TImage) SetOnMouseUp(fn TMouseEvent) {
    Image_SetOnMouseUp(i.instance, fn)
}

func (i *TImage) Action() *TAction {
    return AsAction(Image_GetAction(i.instance))
}

func (i *TImage) SetAction(value IComponent) {
    Image_SetAction(i.instance, CheckPtr(value))
}

func (i *TImage) BiDiMode() TBiDiMode {
    return Image_GetBiDiMode(i.instance)
}

func (i *TImage) SetBiDiMode(value TBiDiMode) {
    Image_SetBiDiMode(i.instance, value)
}

func (i *TImage) BoundsRect() TRect {
    return Image_GetBoundsRect(i.instance)
}

func (i *TImage) SetBoundsRect(value TRect) {
    Image_SetBoundsRect(i.instance, value)
}

// 获取客户区高度。
//
// Get client height.
func (i *TImage) ClientHeight() int32 {
    return Image_GetClientHeight(i.instance)
}

// 设置客户区高度。
//
// Set client height.
func (i *TImage) SetClientHeight(value int32) {
    Image_SetClientHeight(i.instance, value)
}

func (i *TImage) ClientOrigin() TPoint {
    return Image_GetClientOrigin(i.instance)
}

// 获取客户区矩形。
//
// Get client rectangle.
func (i *TImage) ClientRect() TRect {
    return Image_GetClientRect(i.instance)
}

// 获取客户区宽度。
//
// Get client width.
func (i *TImage) ClientWidth() int32 {
    return Image_GetClientWidth(i.instance)
}

// 设置客户区宽度。
//
// Set client width.
func (i *TImage) SetClientWidth(value int32) {
    Image_SetClientWidth(i.instance, value)
}

// 获取控件状态。
//
// Get control state.
func (i *TImage) ControlState() TControlState {
    return Image_GetControlState(i.instance)
}

// 设置控件状态。
//
// Set control state.
func (i *TImage) SetControlState(value TControlState) {
    Image_SetControlState(i.instance, value)
}

// 获取控件样式。
//
// Get control style.
func (i *TImage) ControlStyle() TControlStyle {
    return Image_GetControlStyle(i.instance)
}

// 设置控件样式。
//
// Set control style.
func (i *TImage) SetControlStyle(value TControlStyle) {
    Image_SetControlStyle(i.instance, value)
}

func (i *TImage) Floating() bool {
    return Image_GetFloating(i.instance)
}

// 获取控件父容器。
//
// Get control parent container.
func (i *TImage) Parent() *TWinControl {
    return AsWinControl(Image_GetParent(i.instance))
}

// 设置控件父容器。
//
// Set control parent container.
func (i *TImage) SetParent(value IWinControl) {
    Image_SetParent(i.instance, CheckPtr(value))
}

// 获取左边位置。
//
// Get Left position.
func (i *TImage) Left() int32 {
    return Image_GetLeft(i.instance)
}

// 设置左边位置。
//
// Set Left position.
func (i *TImage) SetLeft(value int32) {
    Image_SetLeft(i.instance, value)
}

// 获取顶边位置。
//
// Get Top position.
func (i *TImage) Top() int32 {
    return Image_GetTop(i.instance)
}

// 设置顶边位置。
//
// Set Top position.
func (i *TImage) SetTop(value int32) {
    Image_SetTop(i.instance, value)
}

// 获取宽度。
//
// Get width.
func (i *TImage) Width() int32 {
    return Image_GetWidth(i.instance)
}

// 设置宽度。
//
// Set width.
func (i *TImage) SetWidth(value int32) {
    Image_SetWidth(i.instance, value)
}

// 获取高度。
//
// Get height.
func (i *TImage) Height() int32 {
    return Image_GetHeight(i.instance)
}

// 设置高度。
//
// Set height.
func (i *TImage) SetHeight(value int32) {
    Image_SetHeight(i.instance, value)
}

// 获取控件光标。
//
// Get control cursor.
func (i *TImage) Cursor() TCursor {
    return Image_GetCursor(i.instance)
}

// 设置控件光标。
//
// Set control cursor.
func (i *TImage) SetCursor(value TCursor) {
    Image_SetCursor(i.instance, value)
}

// 获取组件鼠标悬停提示。
//
// Get component mouse hints.
func (i *TImage) Hint() string {
    return Image_GetHint(i.instance)
}

// 设置组件鼠标悬停提示。
//
// Set component mouse hints.
func (i *TImage) SetHint(value string) {
    Image_SetHint(i.instance, value)
}

// 获取组件总数。
//
// Get the total number of components.
func (i *TImage) ComponentCount() int32 {
    return Image_GetComponentCount(i.instance)
}

// 获取组件索引。
//
// Get component index.
func (i *TImage) ComponentIndex() int32 {
    return Image_GetComponentIndex(i.instance)
}

// 设置组件索引。
//
// Set component index.
func (i *TImage) SetComponentIndex(value int32) {
    Image_SetComponentIndex(i.instance, value)
}

// 获取组件所有者。
//
// Get component owner.
func (i *TImage) Owner() *TComponent {
    return AsComponent(Image_GetOwner(i.instance))
}

// 获取组件名称。
//
// Get the component name.
func (i *TImage) Name() string {
    return Image_GetName(i.instance)
}

// 设置组件名称。
//
// Set the component name.
func (i *TImage) SetName(value string) {
    Image_SetName(i.instance, value)
}

// 获取对象标记。
//
// Get the control tag.
func (i *TImage) Tag() int {
    return Image_GetTag(i.instance)
}

// 设置对象标记。
//
// Set the control tag.
func (i *TImage) SetTag(value int) {
    Image_SetTag(i.instance, value)
}

// 获取左边锚点。
func (i *TImage) AnchorSideLeft() *TAnchorSide {
    return AsAnchorSide(Image_GetAnchorSideLeft(i.instance))
}

// 设置左边锚点。
func (i *TImage) SetAnchorSideLeft(value *TAnchorSide) {
    Image_SetAnchorSideLeft(i.instance, CheckPtr(value))
}

// 获取顶边锚点。
func (i *TImage) AnchorSideTop() *TAnchorSide {
    return AsAnchorSide(Image_GetAnchorSideTop(i.instance))
}

// 设置顶边锚点。
func (i *TImage) SetAnchorSideTop(value *TAnchorSide) {
    Image_SetAnchorSideTop(i.instance, CheckPtr(value))
}

// 获取右边锚点。
func (i *TImage) AnchorSideRight() *TAnchorSide {
    return AsAnchorSide(Image_GetAnchorSideRight(i.instance))
}

// 设置右边锚点。
func (i *TImage) SetAnchorSideRight(value *TAnchorSide) {
    Image_SetAnchorSideRight(i.instance, CheckPtr(value))
}

// 获取底边锚点。
func (i *TImage) AnchorSideBottom() *TAnchorSide {
    return AsAnchorSide(Image_GetAnchorSideBottom(i.instance))
}

// 设置底边锚点。
func (i *TImage) SetAnchorSideBottom(value *TAnchorSide) {
    Image_SetAnchorSideBottom(i.instance, CheckPtr(value))
}

// 获取边框间距。
func (i *TImage) BorderSpacing() *TControlBorderSpacing {
    return AsControlBorderSpacing(Image_GetBorderSpacing(i.instance))
}

// 设置边框间距。
func (i *TImage) SetBorderSpacing(value *TControlBorderSpacing) {
    Image_SetBorderSpacing(i.instance, CheckPtr(value))
}

// 获取指定索引组件。
//
// Get the specified index component.
func (i *TImage) Components(AIndex int32) *TComponent {
    return AsComponent(Image_GetComponents(i.instance, AIndex))
}

// 获取锚侧面。
func (i *TImage) AnchorSide(AKind TAnchorKind) *TAnchorSide {
    return AsAnchorSide(Image_GetAnchorSide(i.instance, AKind))
}

