
//----------------------------------------
// The code is automatically generated by the GenlibLcl tool.
// Copyright © ying32. All Rights Reserved.
// 
// Licensed under Apache License 2.0
//
//----------------------------------------


package vcl


import (
    . "github.com/ying32/govcl/vcl/api"
    . "github.com/ying32/govcl/vcl/types"
    "unsafe"
)

type TUpDown struct {
    IWinControl
    instance uintptr
    // 特殊情况下使用，主要应对Go的GC问题，与LCL没有太多关系。
    ptr unsafe.Pointer
}

// 创建一个新的对象。
// 
// Create a new object.
func NewUpDown(owner IComponent) *TUpDown {
    u := new(TUpDown)
    u.instance = UpDown_Create(CheckPtr(owner))
    u.ptr = unsafe.Pointer(u.instance)
    // 不敢启用，因为不知道会发生什么...
    // runtime.SetFinalizer(u, (*TUpDown).Free)
    return u
}

// 动态转换一个已存在的对象实例。
// 
// Dynamically convert an existing object instance.
func AsUpDown(obj interface{}) *TUpDown {
    instance, ptr := getInstance(obj)
    if instance == 0 { return nil }
    return &TUpDown{instance: instance, ptr: ptr}
}

// -------------------------- Deprecated begin --------------------------
// 新建一个对象来自已经存在的对象实例指针。
// 
// Create a new object from an existing object instance pointer.
// Deprecated: use AsUpDown.
func UpDownFromInst(inst uintptr) *TUpDown {
    return AsUpDown(inst)
}

// 新建一个对象来自已经存在的对象实例。
// 
// Create a new object from an existing object instance.
// Deprecated: use AsUpDown.
func UpDownFromObj(obj IObject) *TUpDown {
    return AsUpDown(obj)
}

// 新建一个对象来自不安全的地址。注意：使用此函数可能造成一些不明情况，慎用。
// 
// Create a new object from an unsecured address. Note: Using this function may cause some unclear situations and be used with caution..
// Deprecated: use AsUpDown.
func UpDownFromUnsafePointer(ptr unsafe.Pointer) *TUpDown {
    return AsUpDown(ptr)
}

// -------------------------- Deprecated end --------------------------
// 释放对象。
// 
// Free object.
func (u *TUpDown) Free() {
    if u.instance != 0 {
        UpDown_Free(u.instance)
        u.instance, u.ptr = 0, nullptr
    }
}

// 返回对象实例指针。
// 
// Return object instance pointer.
func (u *TUpDown) Instance() uintptr {
    return u.instance
}

// 获取一个不安全的地址。
// 
// Get an unsafe address.
func (u *TUpDown) UnsafeAddr() unsafe.Pointer {
    return u.ptr
}

// 检测地址是否为空。
// 
// Check if the address is empty.
func (u *TUpDown) IsValid() bool {
    return u.instance != 0
}

// 检测当前对象是否继承自目标对象。
// 
// Checks whether the current object is inherited from the target object.
func (u *TUpDown) Is() TIs {
    return TIs(u.instance)
}

// 动态转换当前对象为目标对象。
// 
// Dynamically convert the current object to the target object.
//func (u *TUpDown) As() TAs {
//    return TAs(u.instance)
//}

// 获取类信息指针。
// 
// Get class information pointer.
func TUpDownClass() TClass {
    return UpDown_StaticClassType()
}

// 是否可以获得焦点。
func (u *TUpDown) CanFocus() bool {
    return UpDown_CanFocus(u.instance)
}

// 返回是否包含指定控件。
//
// it's contain a specified control.
func (u *TUpDown) ContainsControl(Control IControl) bool {
    return UpDown_ContainsControl(u.instance, CheckPtr(Control))
}

// 返回指定坐标及相关属性位置控件。
//
// Returns the specified coordinate and the relevant attribute position control..
func (u *TUpDown) ControlAtPos(Pos TPoint, AllowDisabled bool, AllowWinControls bool, AllLevels bool) *TControl {
    return AsControl(UpDown_ControlAtPos(u.instance, Pos , AllowDisabled , AllowWinControls , AllLevels))
}

// 禁用控件的对齐。
//
// Disable control alignment.
func (u *TUpDown) DisableAlign() {
    UpDown_DisableAlign(u.instance)
}

// 启用控件对齐。
//
// Enabled control alignment.
func (u *TUpDown) EnableAlign() {
    UpDown_EnableAlign(u.instance)
}

// 查找子控件。
//
// Find sub controls.
func (u *TUpDown) FindChildControl(ControlName string) *TControl {
    return AsControl(UpDown_FindChildControl(u.instance, ControlName))
}

func (u *TUpDown) FlipChildren(AllLevels bool) {
    UpDown_FlipChildren(u.instance, AllLevels)
}

// 返回是否获取焦点。
//
// Return to get focus.
func (u *TUpDown) Focused() bool {
    return UpDown_Focused(u.instance)
}

// 句柄是否已经分配。
//
// Is the handle already allocated.
func (u *TUpDown) HandleAllocated() bool {
    return UpDown_HandleAllocated(u.instance)
}

// 插入一个控件。
//
// Insert a control.
func (u *TUpDown) InsertControl(AControl IControl) {
    UpDown_InsertControl(u.instance, CheckPtr(AControl))
}

// 要求重绘。
//
// Redraw.
func (u *TUpDown) Invalidate() {
    UpDown_Invalidate(u.instance)
}

// 移除一个控件。
//
// Remove a control.
func (u *TUpDown) RemoveControl(AControl IControl) {
    UpDown_RemoveControl(u.instance, CheckPtr(AControl))
}

// 重新对齐。
//
// Realign.
func (u *TUpDown) Realign() {
    UpDown_Realign(u.instance)
}

// 重绘。
//
// Repaint.
func (u *TUpDown) Repaint() {
    UpDown_Repaint(u.instance)
}

// 按比例缩放。
//
// Scale by.
func (u *TUpDown) ScaleBy(M int32, D int32) {
    UpDown_ScaleBy(u.instance, M , D)
}

// 滚动至指定位置。
//
// Scroll by.
func (u *TUpDown) ScrollBy(DeltaX int32, DeltaY int32) {
    UpDown_ScrollBy(u.instance, DeltaX , DeltaY)
}

// 设置组件边界。
//
// Set component boundaries.
func (u *TUpDown) SetBounds(ALeft int32, ATop int32, AWidth int32, AHeight int32) {
    UpDown_SetBounds(u.instance, ALeft , ATop , AWidth , AHeight)
}

// 设置控件焦点。
//
// Set control focus.
func (u *TUpDown) SetFocus() {
    UpDown_SetFocus(u.instance)
}

// 控件更新。
//
// Update.
func (u *TUpDown) Update() {
    UpDown_Update(u.instance)
}

// 将控件置于最前。
//
// Bring the control to the front.
func (u *TUpDown) BringToFront() {
    UpDown_BringToFront(u.instance)
}

// 将客户端坐标转为绝对的屏幕坐标。
//
// Convert client coordinates to absolute screen coordinates.
func (u *TUpDown) ClientToScreen(Point TPoint) TPoint {
    return UpDown_ClientToScreen(u.instance, Point)
}

// 将客户端坐标转为父容器坐标。
//
// Convert client coordinates to parent container coordinates.
func (u *TUpDown) ClientToParent(Point TPoint, AParent IWinControl) TPoint {
    return UpDown_ClientToParent(u.instance, Point , CheckPtr(AParent))
}

// 是否在拖拽中。
//
// Is it in the middle of dragging.
func (u *TUpDown) Dragging() bool {
    return UpDown_Dragging(u.instance)
}

// 是否有父容器。
//
// Is there a parent container.
func (u *TUpDown) HasParent() bool {
    return UpDown_HasParent(u.instance)
}

// 隐藏控件。
//
// Hidden control.
func (u *TUpDown) Hide() {
    UpDown_Hide(u.instance)
}

// 发送一个消息。
//
// Send a message.
func (u *TUpDown) Perform(Msg uint32, WParam uintptr, LParam int) int {
    return UpDown_Perform(u.instance, Msg , WParam , LParam)
}

// 刷新控件。
//
// Refresh control.
func (u *TUpDown) Refresh() {
    UpDown_Refresh(u.instance)
}

// 将屏幕坐标转为客户端坐标。
//
// Convert screen coordinates to client coordinates.
func (u *TUpDown) ScreenToClient(Point TPoint) TPoint {
    return UpDown_ScreenToClient(u.instance, Point)
}

// 将父容器坐标转为客户端坐标。
//
// Convert parent container coordinates to client coordinates.
func (u *TUpDown) ParentToClient(Point TPoint, AParent IWinControl) TPoint {
    return UpDown_ParentToClient(u.instance, Point , CheckPtr(AParent))
}

// 控件至于最后面。
//
// The control is placed at the end.
func (u *TUpDown) SendToBack() {
    UpDown_SendToBack(u.instance)
}

// 显示控件。
//
// Show control.
func (u *TUpDown) Show() {
    UpDown_Show(u.instance)
}

// 获取控件的字符，如果有。
//
// Get the characters of the control, if any.
func (u *TUpDown) GetTextBuf(Buffer *string, BufSize int32) int32 {
    return UpDown_GetTextBuf(u.instance, Buffer , BufSize)
}

// 获取控件的字符长，如果有。
//
// Get the character length of the control, if any.
func (u *TUpDown) GetTextLen() int32 {
    return UpDown_GetTextLen(u.instance)
}

// 设置控件字符，如果有。
//
// Set control characters, if any.
func (u *TUpDown) SetTextBuf(Buffer string) {
    UpDown_SetTextBuf(u.instance, Buffer)
}

// 查找指定名称的组件。
//
// Find the component with the specified name.
func (u *TUpDown) FindComponent(AName string) *TComponent {
    return AsComponent(UpDown_FindComponent(u.instance, AName))
}

// 获取类名路径。
//
// Get the class name path.
func (u *TUpDown) GetNamePath() string {
    return UpDown_GetNamePath(u.instance)
}

// 复制一个对象，如果对象实现了此方法的话。
//
// Copy an object, if the object implements this method.
func (u *TUpDown) Assign(Source IObject) {
    UpDown_Assign(u.instance, CheckPtr(Source))
}

// 获取类的类型信息。
//
// Get class type information.
func (u *TUpDown) ClassType() TClass {
    return UpDown_ClassType(u.instance)
}

// 获取当前对象类名称。
//
// Get the current object class name.
func (u *TUpDown) ClassName() string {
    return UpDown_ClassName(u.instance)
}

// 获取当前对象实例大小。
//
// Get the current object instance size.
func (u *TUpDown) InstanceSize() int32 {
    return UpDown_InstanceSize(u.instance)
}

// 判断当前类是否继承自指定类。
//
// Determine whether the current class inherits from the specified class.
func (u *TUpDown) InheritsFrom(AClass TClass) bool {
    return UpDown_InheritsFrom(u.instance, AClass)
}

// 与一个对象进行比较。
//
// Compare with an object.
func (u *TUpDown) Equals(Obj IObject) bool {
    return UpDown_Equals(u.instance, CheckPtr(Obj))
}

// 获取类的哈希值。
//
// Get the hash value of the class.
func (u *TUpDown) GetHashCode() int32 {
    return UpDown_GetHashCode(u.instance)
}

// 文本类信息。
//
// Text information.
func (u *TUpDown) ToString() string {
    return UpDown_ToString(u.instance)
}

func (u *TUpDown) AnchorToNeighbour(ASide TAnchorKind, ASpace int32, ASibling IControl) {
    UpDown_AnchorToNeighbour(u.instance, ASide , ASpace , CheckPtr(ASibling))
}

func (u *TUpDown) AnchorParallel(ASide TAnchorKind, ASpace int32, ASibling IControl) {
    UpDown_AnchorParallel(u.instance, ASide , ASpace , CheckPtr(ASibling))
}

// 置于指定控件的横向中心。
func (u *TUpDown) AnchorHorizontalCenterTo(ASibling IControl) {
    UpDown_AnchorHorizontalCenterTo(u.instance, CheckPtr(ASibling))
}

// 置于指定控件的纵向中心。
func (u *TUpDown) AnchorVerticalCenterTo(ASibling IControl) {
    UpDown_AnchorVerticalCenterTo(u.instance, CheckPtr(ASibling))
}

func (u *TUpDown) AnchorAsAlign(ATheAlign TAlign, ASpace int32) {
    UpDown_AnchorAsAlign(u.instance, ATheAlign , ASpace)
}

func (u *TUpDown) AnchorClient(ASpace int32) {
    UpDown_AnchorClient(u.instance, ASpace)
}

// 获取四个角位置的锚点。
func (u *TUpDown) Anchors() TAnchors {
    return UpDown_GetAnchors(u.instance)
}

// 设置四个角位置的锚点。
func (u *TUpDown) SetAnchors(value TAnchors) {
    UpDown_SetAnchors(u.instance, value)
}

// 获取设置控件双缓冲。
//
// Get Set control double buffering.
func (u *TUpDown) DoubleBuffered() bool {
    return UpDown_GetDoubleBuffered(u.instance)
}

// 设置设置控件双缓冲。
//
// Set Set control double buffering.
func (u *TUpDown) SetDoubleBuffered(value bool) {
    UpDown_SetDoubleBuffered(u.instance, value)
}

// 获取控件启用。
//
// Get the control enabled.
func (u *TUpDown) Enabled() bool {
    return UpDown_GetEnabled(u.instance)
}

// 设置控件启用。
//
// Set the control enabled.
func (u *TUpDown) SetEnabled(value bool) {
    UpDown_SetEnabled(u.instance, value)
}

// 获取组件鼠标悬停提示。
//
// Get component mouse hints.
func (u *TUpDown) Hint() string {
    return UpDown_GetHint(u.instance)
}

// 设置组件鼠标悬停提示。
//
// Set component mouse hints.
func (u *TUpDown) SetHint(value string) {
    UpDown_SetHint(u.instance, value)
}

func (u *TUpDown) Min() int32 {
    return UpDown_GetMin(u.instance)
}

func (u *TUpDown) SetMin(value int32) {
    UpDown_SetMin(u.instance, value)
}

func (u *TUpDown) Max() int32 {
    return UpDown_GetMax(u.instance)
}

func (u *TUpDown) SetMax(value int32) {
    UpDown_SetMax(u.instance, value)
}

func (u *TUpDown) Increment() int32 {
    return UpDown_GetIncrement(u.instance)
}

func (u *TUpDown) SetIncrement(value int32) {
    UpDown_SetIncrement(u.instance, value)
}

// 获取约束控件大小。
func (u *TUpDown) Constraints() *TSizeConstraints {
    return AsSizeConstraints(UpDown_GetConstraints(u.instance))
}

// 设置约束控件大小。
func (u *TUpDown) SetConstraints(value *TSizeConstraints) {
    UpDown_SetConstraints(u.instance, CheckPtr(value))
}

func (u *TUpDown) Orientation() TUDOrientation {
    return UpDown_GetOrientation(u.instance)
}

func (u *TUpDown) SetOrientation(value TUDOrientation) {
    UpDown_SetOrientation(u.instance, value)
}

// 获取使用父容器双缓冲。
//
// Get Parent container double buffering.
func (u *TUpDown) ParentDoubleBuffered() bool {
    return UpDown_GetParentDoubleBuffered(u.instance)
}

// 设置使用父容器双缓冲。
//
// Set Parent container double buffering.
func (u *TUpDown) SetParentDoubleBuffered(value bool) {
    UpDown_SetParentDoubleBuffered(u.instance, value)
}

// 获取以父容器的ShowHint属性为准。
func (u *TUpDown) ParentShowHint() bool {
    return UpDown_GetParentShowHint(u.instance)
}

// 设置以父容器的ShowHint属性为准。
func (u *TUpDown) SetParentShowHint(value bool) {
    UpDown_SetParentShowHint(u.instance, value)
}

// 获取右键菜单。
//
// Get Right click menu.
func (u *TUpDown) PopupMenu() *TPopupMenu {
    return AsPopupMenu(UpDown_GetPopupMenu(u.instance))
}

// 设置右键菜单。
//
// Set Right click menu.
func (u *TUpDown) SetPopupMenu(value IComponent) {
    UpDown_SetPopupMenu(u.instance, CheckPtr(value))
}

func (u *TUpDown) Position() int32 {
    return UpDown_GetPosition(u.instance)
}

func (u *TUpDown) SetPosition(value int32) {
    UpDown_SetPosition(u.instance, value)
}

// 获取显示鼠标悬停提示。
//
// Get Show mouseover tips.
func (u *TUpDown) ShowHint() bool {
    return UpDown_GetShowHint(u.instance)
}

// 设置显示鼠标悬停提示。
//
// Set Show mouseover tips.
func (u *TUpDown) SetShowHint(value bool) {
    UpDown_SetShowHint(u.instance, value)
}

// 获取Tab切换顺序序号。
//
// Get Tab switching sequence number.
func (u *TUpDown) TabOrder() TTabOrder {
    return UpDown_GetTabOrder(u.instance)
}

// 设置Tab切换顺序序号。
//
// Set Tab switching sequence number.
func (u *TUpDown) SetTabOrder(value TTabOrder) {
    UpDown_SetTabOrder(u.instance, value)
}

// 获取Tab可停留。
//
// Get Tab can stay.
func (u *TUpDown) TabStop() bool {
    return UpDown_GetTabStop(u.instance)
}

// 设置Tab可停留。
//
// Set Tab can stay.
func (u *TUpDown) SetTabStop(value bool) {
    UpDown_SetTabStop(u.instance, value)
}

// 获取控件可视。
//
// Get the control visible.
func (u *TUpDown) Visible() bool {
    return UpDown_GetVisible(u.instance)
}

// 设置控件可视。
//
// Set the control visible.
func (u *TUpDown) SetVisible(value bool) {
    UpDown_SetVisible(u.instance, value)
}

func (u *TUpDown) Wrap() bool {
    return UpDown_GetWrap(u.instance)
}

func (u *TUpDown) SetWrap(value bool) {
    UpDown_SetWrap(u.instance, value)
}

func (u *TUpDown) SetOnChanging(fn TUDChangingEvent) {
    UpDown_SetOnChanging(u.instance, fn)
}

// 设置上下文弹出事件，一般是右键时弹出。
//
// Set Context popup event, usually pop up when right click.
func (u *TUpDown) SetOnContextPopup(fn TContextPopupEvent) {
    UpDown_SetOnContextPopup(u.instance, fn)
}

// 设置控件单击事件。
//
// Set control click event.
func (u *TUpDown) SetOnClick(fn TUDClickEvent) {
    UpDown_SetOnClick(u.instance, fn)
}

// 设置焦点进入。
//
// Set Focus entry.
func (u *TUpDown) SetOnEnter(fn TNotifyEvent) {
    UpDown_SetOnEnter(u.instance, fn)
}

// 设置焦点退出。
//
// Set Focus exit.
func (u *TUpDown) SetOnExit(fn TNotifyEvent) {
    UpDown_SetOnExit(u.instance, fn)
}

// 设置鼠标按下事件。
//
// Set Mouse down event.
func (u *TUpDown) SetOnMouseDown(fn TMouseEvent) {
    UpDown_SetOnMouseDown(u.instance, fn)
}

// 设置鼠标进入事件。
//
// Set Mouse entry event.
func (u *TUpDown) SetOnMouseEnter(fn TNotifyEvent) {
    UpDown_SetOnMouseEnter(u.instance, fn)
}

// 设置鼠标离开事件。
//
// Set Mouse leave event.
func (u *TUpDown) SetOnMouseLeave(fn TNotifyEvent) {
    UpDown_SetOnMouseLeave(u.instance, fn)
}

// 设置鼠标移动事件。
func (u *TUpDown) SetOnMouseMove(fn TMouseMoveEvent) {
    UpDown_SetOnMouseMove(u.instance, fn)
}

// 设置鼠标抬起事件。
//
// Set Mouse lift event.
func (u *TUpDown) SetOnMouseUp(fn TMouseEvent) {
    UpDown_SetOnMouseUp(u.instance, fn)
}

// 获取依靠客户端总数。
func (u *TUpDown) DockClientCount() int32 {
    return UpDown_GetDockClientCount(u.instance)
}

// 获取停靠站点。
//
// Get Docking site.
func (u *TUpDown) DockSite() bool {
    return UpDown_GetDockSite(u.instance)
}

// 设置停靠站点。
//
// Set Docking site.
func (u *TUpDown) SetDockSite(value bool) {
    UpDown_SetDockSite(u.instance, value)
}

// 获取鼠标是否在客户端，仅VCL有效。
//
// Get Whether the mouse is on the client, only VCL is valid.
func (u *TUpDown) MouseInClient() bool {
    return UpDown_GetMouseInClient(u.instance)
}

// 获取当前停靠的可视总数。
//
// Get The total number of visible calls currently docked.
func (u *TUpDown) VisibleDockClientCount() int32 {
    return UpDown_GetVisibleDockClientCount(u.instance)
}

// 获取画刷对象。
//
// Get Brush.
func (u *TUpDown) Brush() *TBrush {
    return AsBrush(UpDown_GetBrush(u.instance))
}

// 获取子控件数。
//
// Get Number of child controls.
func (u *TUpDown) ControlCount() int32 {
    return UpDown_GetControlCount(u.instance)
}

// 获取控件句柄。
//
// Get Control handle.
func (u *TUpDown) Handle() HWND {
    return UpDown_GetHandle(u.instance)
}

// 获取父容器句柄。
//
// Get Parent container handle.
func (u *TUpDown) ParentWindow() HWND {
    return UpDown_GetParentWindow(u.instance)
}

// 设置父容器句柄。
//
// Set Parent container handle.
func (u *TUpDown) SetParentWindow(value HWND) {
    UpDown_SetParentWindow(u.instance, value)
}

func (u *TUpDown) Showing() bool {
    return UpDown_GetShowing(u.instance)
}

// 获取使用停靠管理。
func (u *TUpDown) UseDockManager() bool {
    return UpDown_GetUseDockManager(u.instance)
}

// 设置使用停靠管理。
func (u *TUpDown) SetUseDockManager(value bool) {
    UpDown_SetUseDockManager(u.instance, value)
}

func (u *TUpDown) Action() *TAction {
    return AsAction(UpDown_GetAction(u.instance))
}

func (u *TUpDown) SetAction(value IComponent) {
    UpDown_SetAction(u.instance, CheckPtr(value))
}

// 获取控件自动调整。
//
// Get Control automatically adjusts.
func (u *TUpDown) Align() TAlign {
    return UpDown_GetAlign(u.instance)
}

// 设置控件自动调整。
//
// Set Control automatically adjusts.
func (u *TUpDown) SetAlign(value TAlign) {
    UpDown_SetAlign(u.instance, value)
}

func (u *TUpDown) BiDiMode() TBiDiMode {
    return UpDown_GetBiDiMode(u.instance)
}

func (u *TUpDown) SetBiDiMode(value TBiDiMode) {
    UpDown_SetBiDiMode(u.instance, value)
}

func (u *TUpDown) BoundsRect() TRect {
    return UpDown_GetBoundsRect(u.instance)
}

func (u *TUpDown) SetBoundsRect(value TRect) {
    UpDown_SetBoundsRect(u.instance, value)
}

// 获取客户区高度。
//
// Get client height.
func (u *TUpDown) ClientHeight() int32 {
    return UpDown_GetClientHeight(u.instance)
}

// 设置客户区高度。
//
// Set client height.
func (u *TUpDown) SetClientHeight(value int32) {
    UpDown_SetClientHeight(u.instance, value)
}

func (u *TUpDown) ClientOrigin() TPoint {
    return UpDown_GetClientOrigin(u.instance)
}

// 获取客户区矩形。
//
// Get client rectangle.
func (u *TUpDown) ClientRect() TRect {
    return UpDown_GetClientRect(u.instance)
}

// 获取客户区宽度。
//
// Get client width.
func (u *TUpDown) ClientWidth() int32 {
    return UpDown_GetClientWidth(u.instance)
}

// 设置客户区宽度。
//
// Set client width.
func (u *TUpDown) SetClientWidth(value int32) {
    UpDown_SetClientWidth(u.instance, value)
}

// 获取控件状态。
//
// Get control state.
func (u *TUpDown) ControlState() TControlState {
    return UpDown_GetControlState(u.instance)
}

// 设置控件状态。
//
// Set control state.
func (u *TUpDown) SetControlState(value TControlState) {
    UpDown_SetControlState(u.instance, value)
}

// 获取控件样式。
//
// Get control style.
func (u *TUpDown) ControlStyle() TControlStyle {
    return UpDown_GetControlStyle(u.instance)
}

// 设置控件样式。
//
// Set control style.
func (u *TUpDown) SetControlStyle(value TControlStyle) {
    UpDown_SetControlStyle(u.instance, value)
}

func (u *TUpDown) Floating() bool {
    return UpDown_GetFloating(u.instance)
}

// 获取控件父容器。
//
// Get control parent container.
func (u *TUpDown) Parent() *TWinControl {
    return AsWinControl(UpDown_GetParent(u.instance))
}

// 设置控件父容器。
//
// Set control parent container.
func (u *TUpDown) SetParent(value IWinControl) {
    UpDown_SetParent(u.instance, CheckPtr(value))
}

// 获取左边位置。
//
// Get Left position.
func (u *TUpDown) Left() int32 {
    return UpDown_GetLeft(u.instance)
}

// 设置左边位置。
//
// Set Left position.
func (u *TUpDown) SetLeft(value int32) {
    UpDown_SetLeft(u.instance, value)
}

// 获取顶边位置。
//
// Get Top position.
func (u *TUpDown) Top() int32 {
    return UpDown_GetTop(u.instance)
}

// 设置顶边位置。
//
// Set Top position.
func (u *TUpDown) SetTop(value int32) {
    UpDown_SetTop(u.instance, value)
}

// 获取宽度。
//
// Get width.
func (u *TUpDown) Width() int32 {
    return UpDown_GetWidth(u.instance)
}

// 设置宽度。
//
// Set width.
func (u *TUpDown) SetWidth(value int32) {
    UpDown_SetWidth(u.instance, value)
}

// 获取高度。
//
// Get height.
func (u *TUpDown) Height() int32 {
    return UpDown_GetHeight(u.instance)
}

// 设置高度。
//
// Set height.
func (u *TUpDown) SetHeight(value int32) {
    UpDown_SetHeight(u.instance, value)
}

// 获取控件光标。
//
// Get control cursor.
func (u *TUpDown) Cursor() TCursor {
    return UpDown_GetCursor(u.instance)
}

// 设置控件光标。
//
// Set control cursor.
func (u *TUpDown) SetCursor(value TCursor) {
    UpDown_SetCursor(u.instance, value)
}

// 获取组件总数。
//
// Get the total number of components.
func (u *TUpDown) ComponentCount() int32 {
    return UpDown_GetComponentCount(u.instance)
}

// 获取组件索引。
//
// Get component index.
func (u *TUpDown) ComponentIndex() int32 {
    return UpDown_GetComponentIndex(u.instance)
}

// 设置组件索引。
//
// Set component index.
func (u *TUpDown) SetComponentIndex(value int32) {
    UpDown_SetComponentIndex(u.instance, value)
}

// 获取组件所有者。
//
// Get component owner.
func (u *TUpDown) Owner() *TComponent {
    return AsComponent(UpDown_GetOwner(u.instance))
}

// 获取组件名称。
//
// Get the component name.
func (u *TUpDown) Name() string {
    return UpDown_GetName(u.instance)
}

// 设置组件名称。
//
// Set the component name.
func (u *TUpDown) SetName(value string) {
    UpDown_SetName(u.instance, value)
}

// 获取对象标记。
//
// Get the control tag.
func (u *TUpDown) Tag() int {
    return UpDown_GetTag(u.instance)
}

// 设置对象标记。
//
// Set the control tag.
func (u *TUpDown) SetTag(value int) {
    UpDown_SetTag(u.instance, value)
}

// 获取左边锚点。
func (u *TUpDown) AnchorSideLeft() *TAnchorSide {
    return AsAnchorSide(UpDown_GetAnchorSideLeft(u.instance))
}

// 设置左边锚点。
func (u *TUpDown) SetAnchorSideLeft(value *TAnchorSide) {
    UpDown_SetAnchorSideLeft(u.instance, CheckPtr(value))
}

// 获取顶边锚点。
func (u *TUpDown) AnchorSideTop() *TAnchorSide {
    return AsAnchorSide(UpDown_GetAnchorSideTop(u.instance))
}

// 设置顶边锚点。
func (u *TUpDown) SetAnchorSideTop(value *TAnchorSide) {
    UpDown_SetAnchorSideTop(u.instance, CheckPtr(value))
}

// 获取右边锚点。
func (u *TUpDown) AnchorSideRight() *TAnchorSide {
    return AsAnchorSide(UpDown_GetAnchorSideRight(u.instance))
}

// 设置右边锚点。
func (u *TUpDown) SetAnchorSideRight(value *TAnchorSide) {
    UpDown_SetAnchorSideRight(u.instance, CheckPtr(value))
}

// 获取底边锚点。
func (u *TUpDown) AnchorSideBottom() *TAnchorSide {
    return AsAnchorSide(UpDown_GetAnchorSideBottom(u.instance))
}

// 设置底边锚点。
func (u *TUpDown) SetAnchorSideBottom(value *TAnchorSide) {
    UpDown_SetAnchorSideBottom(u.instance, CheckPtr(value))
}

func (u *TUpDown) ChildSizing() *TControlChildSizing {
    return AsControlChildSizing(UpDown_GetChildSizing(u.instance))
}

func (u *TUpDown) SetChildSizing(value *TControlChildSizing) {
    UpDown_SetChildSizing(u.instance, CheckPtr(value))
}

// 获取边框间距。
func (u *TUpDown) BorderSpacing() *TControlBorderSpacing {
    return AsControlBorderSpacing(UpDown_GetBorderSpacing(u.instance))
}

// 设置边框间距。
func (u *TUpDown) SetBorderSpacing(value *TControlBorderSpacing) {
    UpDown_SetBorderSpacing(u.instance, CheckPtr(value))
}

// 获取指定索引停靠客户端。
func (u *TUpDown) DockClients(Index int32) *TControl {
    return AsControl(UpDown_GetDockClients(u.instance, Index))
}

// 获取指定索引子控件。
func (u *TUpDown) Controls(Index int32) *TControl {
    return AsControl(UpDown_GetControls(u.instance, Index))
}

// 获取指定索引组件。
//
// Get the specified index component.
func (u *TUpDown) Components(AIndex int32) *TComponent {
    return AsComponent(UpDown_GetComponents(u.instance, AIndex))
}

// 获取锚侧面。
func (u *TUpDown) AnchorSide(AKind TAnchorKind) *TAnchorSide {
    return AsAnchorSide(UpDown_GetAnchorSide(u.instance, AKind))
}

